function uc = ftoc1(uf)
%
% Fine to coarse`(one level) intergrid transfer by full wieghting.
% We assume that 
% n = length(u) = 2^l + 1
% which means the grids are nested.
%
nf = length(uf);
nc = (nf-1)/2 + 1;
uc=zeros(nc,1);
%
% Injection on the boundaries
%
uc(1) = uf(1); uc(nc)=uf(nf);
%
% Full weighting everywhere else.
%
uc(2:nc-1) = .25*(uf(1:2:nf-3) + 2*uf(2:2:nf-2) + uf(3:2:nf-1));
